<?php

//Add forgetfail user to wordpress

if(isset($_POST['password']))
{
    $response = wp_remote_post(  'http://forgetfail.com/api/user/authenticate', array(
        'method' => 'POST',
        'timeout' => 45,
        'redirection' => 5,
        'httpversion' => '1.0',
        'blocking' => true,
        'headers' => array(),
        'body' => array( 'email' => $_POST['email'], 'password' => $_POST['password'] ),
        'cookies' => array()
        )
    );     
    
    $body =  json_decode($response['body']);

    //if there is an error we will display it otherwise we will add the email and users api to wordpress

    if($body->error)
    {

        echo '<span class="error">'.$body->error.'</span>';

    }
    else {

        $private_api_key =  $body->private_api_key;

        $email = $_POST['email'];


        $wpdb->query( 
            $wpdb->prepare( 
                " DELETE FROM $wpdb->options
                 WHERE option_name = %s
                 or option_name = %s
                ",
                 'forgetfail_email','forgetfail_private_api_key'

            )
        );


        $wpdb->query( 
            $wpdb->prepare( 
                "INSERT INTO $wpdb->options
                 (option_name,option_value,autoload)
                  Values 
                  ('forgetfail_email', %s,'no'),
                  ('forgetfail_private_api_key', %s,'no')  
                  ",
                  $email,$private_api_key
            )
        );
    }
}

//Get Variables we may need

$forgetfail_email = $wpdb->get_var("select option_value from $wpdb->options where option_name = 'forgetfail_email'"); 

$forgetfail_private_api_key = $wpdb->get_var("select option_value from $wpdb->options where option_name = 'forgetfail_private_api_key'"); 

$forgetfail_database_api_key = $wpdb->get_var("select option_value from $wpdb->options where option_name = 'forgetfail_database_api_key'"); 

//Check to see if private_api_key is set up with forgetfail

if($forgetfail_private_api_key)
{
     $response = wp_remote_get(  'http://forgetfail.com/api/user/plan?user_api_key='.$forgetfail_private_api_key);

     $body =  json_decode($response['body']);

     //If error then there is an error with the saved api key and user needs to be re authenticated.  Flag and show login.  Else show plan information

     if ($body->error)
     {
         $forgetfail_email = null;
         $forgetfail_private_api_key = null;
         $forgetfail_database_api_key = null;
     }

     else
     {
         $forgetfail_plan = $body->plan;
     }
}

//Add database to forgetfail and store info in wordpress

if(isset($_POST['database_name']))
{
    $url = home_url();

    $response = wp_remote_post(  'http://forgetfail.com/api/database/create', array(
        'method' => 'POST',
        'timeout' => 45,
        'redirection' => 5,
        'httpversion' => '1.0',
        'blocking' => true,
        'headers' => array(),
        'body' => array( 
            'user_api_key' => $forgetfail_private_api_key,
            'name' => $_POST['database_name'], 
            'url' => $url,
            'interval' => $_POST['interval']
            ),
        'cookies' => array()
        )
    );   

    $body =  json_decode($response['body']);

    $database_api_key = $body->database_api_key;
   
   $wpdb->query(
        $wpdb->prepare(
            "DELETE FROM $wpdb->options 
            WHERE option_name = %s
            or option_name = %s
            or option_name = %s",
            'forgetfail_database_api_key','forgetfail_database_name','forgetfail_database_interval'
        )

    );

    $wpdb->query(
        $wpdb->prepare(
            "INSERT INTO $wpdb->options
            (option_name,option_value,autoload)
            Values
            ('forgetfail_database_api_key', %s, 'no'),
            ('forgetfail_database_name', %s, 'no'),
            ('forgetfail_database_interval', %s, 'no')
            ",
            $database_api_key,$_POST['database_name'],$_POST['interval']
            )
     );

     $forgetfail_database_api_key = $database_api_key;

}

//Remove database from wordpress and forgetfail

if(isset($_POST['database_delete']))
{
 
   $wpdb->query(
        $wpdb->prepare(
            "DELETE FROM $wpdb->options 
            WHERE option_name = %s
            or option_name = %s
            or option_name = %s",
            'forgetfail_database_api_key','forgetfail_database_name','forgetfail_database_interval'
        )

    );
     $response = wp_remote_post(  'http://forgetfail.com/api/database/delete', array(
        'method' => 'POST',
        'timeout' => 45,
        'redirection' => 5,
        'httpversion' => '1.0',
        'blocking' => true,
        'headers' => array(),
        'body' => array( 
            'user_api_key' => $forgetfail_private_api_key,
            'api_key' => $forgetfail_database_api_key
            ),
        'cookies' => array()
        )
    );   

    $forgetfail_database_api_key = null;
}
?>

<p class="wrap">  
        <?php screen_icon('themes'); ?> 
<h2>Forgetfail</h2>  
  <?php if(!$forgetfail_email): ?>
        <form method="POST" action="">  
            <table class="form-table">  
                <tr valign="top">  
                    <th scope="row">  
                        <label for="email">  
                            Forgetfail Email
                        </label>  
                    </th>  
                    <td>  
                        <input type="text" name="email"  />  
                    </td>  
                </tr>  
                
                 <tr valign="top">  
                    <th scope="row">  
                        <label for="password">  
                            Forgetfail Password 
                        </label>  
                    </th>  
                    <td>  
                        <input type="password" name="password"  />  
                    </td>
                </tr>
                
                 <tr valign="top">  
                    <th scope="row">  
                    </th>  
                    <td>  
                        <input type="submit" name="submit"  />  
                    </td>
                </tr>
            </table>  
        </form>  
    </p> 

<?php else: ?>
<p>
    User is correctly set up with the <?php echo $forgetfail_plan; ?> plan
    <hr />
</p>

<?php endif; ?>

<?php if($forgetfail_private_api_key && !$forgetfail_database_api_key): ?>

<p>
<h1>Add this database to backup with Forgetfail</h1>
    <form method = "POST" action = "">
        <table class="form-table">  
            <tr valign="top">
                <th scope="row">
                    <label for="name">Name

                    </label>
                </th>
                <td>
                    <input type="text" name="database_name" value="<?php echo get_bloginfo('name'); ?>"/>
                </td>
            </tr>
             <tr valign="top">
                <th scope="row">
                    <label for="interval">Backup Interval

                    </label>
                </th>
                <td>
                    <?php $intervals = array(
                        '1 Hour' => '3600',
                        '12 Hours' => '43200',
                        '24 Hours' => '86400',
                        '1 Week' => '604800',
                        '2 Weeks' => '1209600',
                        '30 Days' => '2592000'
                        ); ?>  
                    <select name="interval">
                        <?php foreach ($intervals as $interval=>$seconds): ?>
                        <option value="<?php echo $seconds; ?>" ><?php echo $interval; ?></option>
                        <?php endforeach; ?>
                    </selct>
                </td>
            </tr>
            <tr valign="top">  
                <th scope="row">  
                </th>  
                <td>  
                    <input type="submit" name="submit"  value="Add This Database" />  
                </td>
            </tr>
      </table>
    </form>
</p>

<?php elseif($forgetfail_database_api_key): ?>

<p>
    Database is currently added to your forgetfail plan
    <form method="post" action="" onsubmit="return confirmDelete();">
        <input type="submit" name="database_delete" value="Remove Database" />
    </form>
</p>

<script type="text/javascript">
function confirmDelete()
{
    return confirm('Are you sure you want to remove theis database from your Forgetfail account?');
}
</script>
<?php endif; ?>