<?php 
define('FORGETFAIL_HOST', DB_HOST);	// Host of mysql database
define('FORGETFAIL_PORT', 3306);			// Port of mysql (Usually 3306)
define('FORGETFAIL_DATABASE', DB_NAME); 	// Database to backup
define('FORGETFAIL_USER', DB_USER); 		// User of mysql database
define('FORGETFAIL_PASSWORD', DB_PASSWORD); 		// Password of mysql database
define('FORGETFAIL_API_KEY', $forgetfail_database_api_key) ;		// Your API Key
define('FORGETFAIL_DATA_FOLDER', WP_PLUGIN_DIR.'/forgetfail/data'); // Folder to use for backups
define('FORGETFAIL_COMPRESS', true); // Use gz to compress backup, saves bandwidth, usually by 90%
define('FORGETFAIL_PATH', plugin_dir_url(__FILE__).'data');
define('FORGETFAIL_TIME', time());
set_time_limit(0);
ini_set('memory_limit', '1000M');

class Forgetfail{

	public $filename = null;

	public $fileurl = null;

	private function filename()
	{
		if(is_null($this->filename))
			return FORGETFAIL_DATA_FOLDER.'/'.FORGETFAIL_TIME;

		return $this->filename;
	}

	private function fileurl()
	{
		if(is_null($this->fileurl))
			return FORGETFAIL_PATH.'/'.FORGETFAIL_TIME;

		return $this->fileurl;
	}

	function do_backup()
	{
		$return = '';
		$tables = $return_arr = array();
		$result = mysql_query('SHOW TABLES');

		while($row = mysql_fetch_row($result))
		{
			$return = "SET FOREIGN_KEY_CHECKS=0;\n\n";

			$tables[] = $row[0];
		}

		foreach($tables as $table)
		{
			$result = mysql_query('SELECT * FROM '.$table);
			$num_fields = mysql_num_fields($result);

			$return .= 'DROP TABLE IF EXISTS '.$table.';';
			$row2 = mysql_fetch_row(mysql_query('SHOW CREATE TABLE '.$table));
			$return .= "\n\n".$row2[1].";\n\n";

			for ($i = 0; $i < $num_fields; $i++)
			{
				while($row = mysql_fetch_row($result))
				{
					$return .= 'INSERT INTO '.$table.' VALUES(';

					for($j=0; $j < $num_fields; $j++)
					{
						$row[$j] = addslashes($row[$j]);
						$row[$j] = preg_replace("#\n#", "\\n", $row[$j]);
						if (isset($row[$j])) { $return.= '"'.$row[$j].'"' ; } else { $return.= '""'; }
						if ($j<($num_fields-1)) { $return.= ','; }
					}
					$return.= ");\n";
				}
			}

			$return .= "\n\n\n";
		}

		$return .= "SET FOREIGN_KEY_CHECKS=1;\n";

		return $this->save_backup($return);
	}

	private function save_backup($return)
	{
		$compressed = false;

		if(FORGETFAIL_COMPRESS && function_exists('gzcompress'))
		{
			$return = gzcompress($return,9);
			$compressed = true;
		}

		$filename = $this->filename();
		$file = fopen($filename, "w");
		fwrite($file, $return);
		fclose($file);
		$fileurl = $this->fileurl();
		$return_arr = array('filename' => $fileurl, 'compressed' => $compressed);

		return json_encode($return_arr);
	}

	public function delete_backups()
	{
		foreach(glob(FORGETFAIL_DATA_FOLDER . '/*') as $file)
		{
		  unlink($file);
	 	}

		return json_encode(true);
	}

}

if(!mysql_connect(FORGETFAIL_HOST.':'.FORGETFAIL_PORT, FORGETFAIL_USER, FORGETFAIL_PASSWORD))
{
	die(json_encode(array(
		'fail' => true,
		'message' => 'Could not connect to the MySQL server'
	)));
}

if(!mysql_select_db(FORGETFAIL_DATABASE))
{
	die(json_encode(array(
		'fail' => true,
		'message' => 'Could not connect to the MySQL database'
	)));
}


if(isset($_GET['action']))
{
	$forgetfail = new Forgetfail();

	switch($_GET['action'])
	{
		case 'backup':
			die($forgetfail->do_backup());
			break;

		case 'delete':
			die($forgetfail->delete_backups());
			break;

		case 'test':
			die(json_encode(array(
				'test' => true
			)));
			break;
	}
}

echo json_encode(array(
	'fail' => true,
	'message' => 'No valid action given'
));